#!/usr/bin/perl

$clear=`which clear`; chomp $clear;
system($clear);

print "Running Instalation program. Please wait\n";
#   ASP9!
`ln -s /opt/lingate/www/lingate /var/www/html/lingate`;
#-    /opt/lingate/www  -  apache;
#-     apache  AddDefaultCharset WINDOWS-1251   /etc/httpd/httpd.conf
#AddDefaultCharset WINDOWS-1251

`cp -f /etc/httpd/conf/httpd.conf /etc/httpd/conf/httpd.conf.bak 2>&1`;
open (INI,">/etc/httpd/conf/httpd.conf");
open (BAK,"</etc/httpd/conf/httpd.conf.bak");
while (<BAK>) {
	chomp;
	if ((!/^[;#]/) and ($_ ne '')) {
		/^(\S+)\s*?["']{0,1}([^"']*?)["']{0,1}$/;
		if ($1 eq 'AddDefaultCharset') {
			$_='AddDefaultCharset WINDOWS-1251';
			}
		}
	print INI $_."\n";
	}
close INI;
close BAK;


`cp -f /etc/sysctl.conf /etc/sysctl.conf.bak 2>&1`;
open (INI,">/etc/sysctl.conf");
open (BAK,"</etc/sysctl.conf.bak");
while (<BAK>) {
	chomp;
	if ((!/^[;#]/) and ($_ ne '')) {
		/^(\S+)\s*?=\s*?(.*?)$/;
		if ($1 eq 'net.ipv4.ip_forward') {
			$_='net.ipv4.ip_forward = 1';
			}
		}
	print INI $_."\n";
	}
close INI;
close BAK;


#  mysql  httpd     
chdir('/');
`ln -s /etc/rc.d/init.d/httpd /etc/rc.d/rc3.d/S55httpd`;
`/etc/rc.d/init.d/httpd start`;
`ln -s /etc/rc.d/init.d/mysqld /etc/rc.d/rc3.d/S55mysqld`;
`/etc/rc.d/init.d/mysqld start`;
sleep 10;
# /  ASP9!


$version='1.5';

$find=`which find`; chomp $find;
$tar=`which tar`; chomp $tar;
$mysql=`which mysql`; chomp $mysql;
$mysqladmin=`which mysqladmin`; chomp $mysqladmin;
$ls=`which ls`; chomp $ls;
$ps=`which ps`; chomp $ps;
$ping=`which ping`; chomp $ping;
$grep=`which grep`; chomp $grep;
$sort=`which sort`; chomp $sort;
$iptables=`which iptables`; chomp $iptables;

open (INSTALL,'/var/opt/lingate.install');
while (<INSTALL>) {
	/^(.*?)\s*=\s*(.*)$/;
	$installed{$1}=$2;
	}
close INSTALL;

$mysql_run=`$ps ax | $grep mysqld | grep -v grep`;
die "[!] Fatal error: MySQL server didnt launched\n" if ($mysql_run eq '');

#################################
#     
#################################
@httpds=`$ps auxwww | $grep http | $grep -v grep`;
foreach $httpd (@httpds) {
	$httpd=~/^(\S+)\s+/;
	$httpd_user=$1 if ($1 ne 'root');
	}
if ($httpd_user eq '') {
	print "Apache httpd server didnt run. Cant determinate apache user name. Please type it: ";
	$httpd_user=<>; chomp $httpd_user;
	}
print "[*] Found web-server name: $httpd_user\n";

#################################
#    /opt   
#################################
if ($installed{'targz'} eq $version) {
	print "[s] Skipped: Distributive files installing\n";
	}
else {
	chdir('/opt');
	print "[w] Distributive file instalation...";
	$err=`$tar xzf /mnt/cdrom/lingate.tar.gz 2>&1`;
	die "\n[!] Fatal error: Cant unpack distributive file\n" if ($err ne '');
	`chown -R root.$httpd_user /opt/lingate`;
	print "\n";
	&install('targz');
	}

#################################
#  PHP,     php.ini
#################################
print "[*] Searching for PHP in /usr...\n";
@phps=`$find /usr -type f -perm +444 -path '*/php'`; chomp @phps;

if (@phps) {
	if (@phps==1) {
		$php=$phps[0];
		}
	else {
		print "Found several PHP interpretators\n";
		for ($i=1;$i<@phps+1;$i++) {
			print $i.': '.$phps[$i-1]."\n";
			}
		print "$i: Enter path to PHP interpretator by self\n... your choise N: ";
		do {
			$number=<>;
			} while ( ($number<0) || ($number>(@phps+1)) );
		if ($number==$i) {
			print "Enter path to PHP: ";
			$php=<>;
			chomp $php;
			}
		else {
			$php=$phps[$number-1];
			}
		}
	}
else {
	print "PHP interpretator not found, please enter path to it: ";
	$php=<>;
	chomp $php;
	}

$_=`$php -v`; /(\d+\.\d+\.\d+)/; $php_version=$1;
die "[!] Fatal error: Can't determinate PHP version ($php)\n" if ($php_version eq '');
$_=`$php -i`;
if (/Configuration File \(php\.ini\) Path =\> (.*)/) {
	# cli
	$php_ini=$1;
	} # \>
elsif (/\>Configuration File \(php\.ini\) Path.*?\>([^<]+)\<\/td\>\<\/tr\>/) {
	# html
	$php_ini=$1;
	}
if ($php_ini!~/php\.ini/) {
	$php_ini.='/php.ini';
	}
die "[!] Fatal error: Can't determinate php.ini position ($php)\n" if ($php_ini eq '');
print "Found PHP v.$php_version: [$php].\nPath to php.ini: $php_ini\n";


#################################
#  php.ini    
#################################
open (TMP,"/mnt/cdrom/TurckLoader/$php_version/TurckLoader.so") or
	die "[!] Fatal error: Can't found TurckLoader decoding module for your PHP version (v.$php_version)\n";
close TMP;
print "[*] Changing php.ini. Backup copy is stored in $php_ini.bak\n";
`cp -f $php_ini $php_ini.bak 2>&1`;
open (INI,">$php_ini");
open (BAK,"<$php_ini.bak");
$extension_need=1;
$safe_mode_need=1;
while (<BAK>) {
	chomp;
	if ((!/^[;#]/) and ($_ ne '')) {
		/^(\S+)\s*?=\s*?["']{0,1}([^"']*?)["']{0,1}$/;
		if ($1 eq 'safe_mode') {
			$_='safe_mode = On';
			$safe_mode_need=0;
			}
		elsif ($1 eq 'register_globals') {
			$_='register_globals = On';
			}
		elsif ($1 eq 'safe_mode_exec_dir') {
			$safe_mode_exec_dir=$2 if ($2 ne '');
			}
		elsif ($1 eq 'extension_dir') {
			$extension_dir=$2 if ($2 ne '');
			}
		elsif ($1 eq 'extension') {
			$extension_need=0 if ($2 eq 'TurckLoader.so');
			}
		}
	print INI $_."\n";
	}
if ($safe_mode_need) {
	print INI "safe_mode = On\n";
	}
if ($safe_mode_exec_dir eq '') {
	print INI "safe_mode_exec_dir=/opt/lingate/safe_php\n";
	$safe_mode_exec_dir='/opt/lingate/safe_php';
	}
if ($extension_dir eq '') {
	print INI "extension_dir=/opt/lingate/extension_php\n";
	$extension_dir='/opt/lingate/extension_php';
	}
if ($extension_need) {
	print INI "extension=TurckLoader.so\n";
	print "[w] Copy TurckLoader PHP decoder module from /mnt/cdrom/TurckLoader/$php_version/TurckLoader.so into $extension_dir\n";
	`cp /mnt/cdrom/TurckLoader/$php_version/TurckLoader.so $extension_dir/`;
	}
close INI;
close BAK;
print "[w] php.ini succesfully changed. You need to restart apache (or whole server) after lingate instalation is complete\n";


#################################
#    ,  
#################################
print "\nSetting up MySQL database to work with lingate\n";
print "Enter database name (you may choose 'lingate'): ";
do { $db=<>; chomp $db; } while ( ($db!~/^\w+$/) || ($db eq '') );
print "Enter database user name (usualy 'lingate'): ";
do { $user=<>; chomp $user; } while ( ($user!~/^\w+$/) || ($user eq '') );
print "Enter database user password: ";
do { $pass=<>; chomp $pass; } while ( ($pass!~/^\S+$/) || ($pass eq '') );
print "Is database already exists? [Y/N]: ";
do { $exist=<>; chomp $exist; $exist=lc $exist; } while ( ($exist ne 'y') && ($exist ne 'n') );
if ($exist eq 'n') {
	#[+]  ,    login [root]   [].   . ,   .
	print "Enter MySQL database administrator name (usualy 'root'): ";
	do { $root_user=<>; chomp $root_user; } while ( ($root_user!~/^\w+$/) || ($root_user eq '') );
	print "Enter MySQL administrator password: ";
	$root_pass=<>; chomp $root_pass;
	$to_exec="$mysqladmin -u$root_user ".(($root_pass)?"-p$root_pass ":'')."create $db 2>&1";
	$err=`$to_exec`;
	die "[!] Fatal error: Can't create database $db\n[!] MySQL error: $err\n" if ($err ne '');
	$to_exec="echo \"grant all privileges on $db.* to $user\@localhost identified by '$pass'\" | mysql -u$root_user ".(($root_pass)?"-p$root_pass ":'')."2>&1";
	$err=`$to_exec`;
	die "[!] Fatal error: Can't grant privileges to user $user on database $db\n[!] MySQL error: $err\n" if ($err ne '');
	print "[w] Database $db is created. Successfull granted privileges on it for user $user\n";
	}
@files=`$ls /opt/lingate/install/*.sql | $sort`; chomp @files;
foreach $file (@files) {
	$err=`$mysql -u$user -p$pass $db < $file 2>&1`;
	die "[!] Fatal error: Can't import $file into MySQL database $db\n[!] MySQL error: $err\n" if ($err ne '');
	}
print "[w] Database schema is succesfully imported\n";


#################################
#   iptables, ,  ,  
#################################
$my_secret=int(rand()*100000000);
open (CRON,">>/etc/crontab");
print CRON "* * * * * root /opt/lingate/lib/daemon.php 2>/dev/null >/dev/null\n";
close CRON;
print "[w] Added minutly call to lib/daemon.php into /etc/crontab\n";

open (START,">>/etc/rc.d/rc.local");
print START "/opt/lingate/lib/start.php\n";
close START;
print "[w] Added lingate autorun (lib/start.php) into /etc/rc.d/rc.local\n";

`cp $ping $safe_mode_exec_dir/`;
`chown root.$httpd_user $safe_mode_exec_dir/ping`;
`chmod 750 $safe_mode_exec_dir/ping`;
`chmod u+s $safe_mode_exec_dir/ping`;
print "[w] The 'ping' command copied into $safe_mode_exec_dir folder for lingate integration\n";

`chown root.$httpd_user $iptables`;
`chmod 750 $iptables`;
`chmod u+s $iptables`;
print "[w] Changed permission on $iptables (root.$httpd_user 750 +SUID) for lingate integration\n";

open (ROUTE,'/proc/net/route');
while (<ROUTE>) {
	if (/^(\S+)\s+00000000\s+/) {
		$ext_dev=$1;
		break;
		}
	}
close ROUTE;
if ($ext_dev eq '') {
	print "[?] Can't automaticaly find external network interface. Please type it (usualy 'eth0'): ";
	do { $ext_dev=<>; chomp $ext_dev; } while ( ($ext_dev!~/^\S+$/) || ($ext_dev eq '') );
	}
else {
	print "[*] Found external network interface $ext_dev\n";
	}

print "[?] Enter lingate WEB-server address:";
do { $web_host=<>; chomp $web_host; } while ( ($web_host!~/^\S+$/) || ($web_host eq '') );


open (CONFIG,'>/opt/lingate/lingate.local.conf');
print CONFIG "<?
\$IPTABLES['PATH']  ='iptables-wrapper.sh';
\$IPTABLES['SECRET']='$my_secret';
\$IPTABLES['DEV']   ='$ext_dev';

\$SQUID['access.log']='/var/log/squid/access.log';
\$NACCTD['log']='/var/log/net-acct';

\$WEB_HOST='$web_host';

\$db=new db('localhost','$user','$pass','$db');
?>
";
close CONFIG;
print "[w] Created file /opt/lingate/lingate.local.conf. Please check it after instalation\n";

open (LIB,'>/opt/lingate/lib/start.php');
print LIB "#!$php\n";
close LIB;
open (LIB,'>/opt/lingate/lib/daemon.php');
print LIB "#!$php\n";
close LIB;
open (LIB,'>/opt/lingate/lib/squid.rotate.php');
print LIB "#!$php\n";
close LIB;
`cat /opt/lingate/install/lib/start.php >> /opt/lingate/lib/start.php`;
`cat /opt/lingate/install/lib/daemon.php >> /opt/lingate/lib/daemon.php`;
`cat /opt/lingate/install/lib/squid.rotate.php >> /opt/lingate/lib/squid.rotate.php`;
`chmod +x /opt/lingate/lib/start.php`;
`chmod +x /opt/lingate/lib/daemon.php`;
`chmod +x /opt/lingate/lib/squid.rotate.php`;
print "[w] Into running files in /opt/lingate/lib folder wrote PHP interpretator path\n";

open (LIB,">$safe_mode_exec_dir/iptables-wrapper.sh");
print LIB "#!/bin/sh

SECRET=\$1

if [ \$SECRET = '$my_secret' ]; then
	shift
	$iptables \$*
fi
";
close LIB;
`chmod +x $safe_mode_exec_dir/iptables-wrapper.sh`;
print "[w] Created file $safe_mode_exec_dir/iptables-wrapper.sh for security lingate integration with iptables\n";

`/etc/rc.d/init.d/httpd restart`;
print "[*] Apache WEB-server is restarted\n";


print "


Instalation is successfuly completed!
For beginning of work you must restart Lingate server
 or restart theese services: apache, network, mysql.

**********************************************************
*** Press Enter key for exit from instalation programm ***
**********************************************************
";<>;


sub install() {
	my $module=shift;
	
	$installed{$module}=$version;
	open (INSTALL,'>/var/opt/lingate.install');
	foreach $key (keys %installed) {
		print INSTALL $key.'='.$installed{$key}."\n";
		}
	close INSTALL;
	}
