#  
drop table if exists config;
create table config (
	module   char(50) not null,		# 
	param    char(50) not null,		# 
	value    char(254) not null,	# 
	DC       timestamp not null,	# Datetime 
	primary key (module,param)
	);

INSERT INTO config (module, param, value, DC) VALUES ('common','inet_time','0',20040416113652);
INSERT INTO config (module, param, value, DC) VALUES ('common','inet_ip1','195.34.32.10',20040416113652);
INSERT INTO config (module, param, value, DC) VALUES ('common','inet_ip2','',20040416113652);
INSERT INTO config (module, param, value, DC) VALUES ('common','inet_ip3','',20040416113652);
INSERT INTO config (module, param, value, DC) VALUES ('common','ssh_out','0',20040416113652);
INSERT INTO config (module, param, value, DC) VALUES ('common','ssh_in','0',20040416113652);
INSERT INTO config (module, param, value, DC) VALUES ('common','web_out','0',20040416113652);
INSERT INTO config (module, param, value, DC) VALUES ('common','menu_icon','1',20040416113652);
INSERT INTO config (module, param, value, DC) VALUES ('common','user_next','0',20040416113652);
INSERT INTO config (module, param, value, DC) VALUES ('common','exit_close','0',20040416113652);
INSERT INTO config (module, param, value, DC) VALUES ('common','window_size','%',20040416113652);
INSERT INTO config (module, param, value, DC) VALUES ('common','window_size_px_width','600',20040416113652);
INSERT INTO config (module, param, value, DC) VALUES ('common','window_size_px_hight','500',20040416113652);
INSERT INTO config (module, param, value, DC) VALUES ('common','window_size_pc_width','80',20040416113652);
INSERT INTO config (module, param, value, DC) VALUES ('common','window_size_pc_hight','90',20040416113652);
INSERT INTO config (module, param, value, DC) VALUES ('common','window_position','top',20040416113652);
INSERT INTO config (module, param, value, DC) VALUES ('common','inet_login_on','0',20040416113652);
INSERT INTO config (module, param, value, DC) VALUES ('common','inet_exit_off','0',20040416113652);
INSERT INTO config (module, param, value, DC) VALUES ('common','inet_close_off','0',20040416113652);


#   
drop table if exists message;
create table message (
	id       bigint primary key auto_increment,	# ID
	title    text not null,			#  
	content  text not null,			# 
	priority tinyint not null,		#  
	DM       timestamp not null,	# Datetime 
	DC       timestamp not null		# Datetime 
	);

insert into menu (id,pid,name,order_id,DC) values ('config','','',3,NOW());

insert into menu (id,pid,name,order_id,DC) values ('common','config','',1,NOW());
insert into menu (id,pid,name,order_id,DC) values ('trafic','config','',2,NOW());
#insert into menu (id,pid,name,order_id,DC) values ('backup','config','BackUp',3,NOW());
insert into menu (id,pid,name,order_id,DC) values ('report','config','',4,NOW());
#insert into menu (id,pid,name,order_id,DC) values ('www','config','WWW  FTP',5,NOW());
insert into menu (id,pid,name,order_id,DC) values ('message','config','',6,NOW());
#insert into menu (id,pid,name,order_id,DC) values ('cache','config','',7,NOW());
#insert into menu (id,pid,name,order_id,DC) values ('network','config','',8,NOW());


insert into menu (id,pid,name,order_id,DC) values ('profile','config','',8,NOW());
drop table if exists profile;
create table profile (
	id       bigint primary key auto_increment,	# ID
	name     varchar(250) not null,	#  
	access   tinyint not null,		#   (0),      (1)   (2)
	services text not null,			#    =1  =2
	DM       timestamp not null,	# Datetime 
	DC       timestamp not null		# Datetime 
	);
