#!/usr/bin/perl

$clear=`which clear`; chomp $clear;
system($clear);

print "  Lingate. , \n";
#   ASP9!
`ln -s /opt/lingate/www/lingate /var/www/html/lingate`;
#-    /opt/lingate/www  -  apache;
#-     apache  AddDefaultCharset WINDOWS-1251   /etc/httpd/httpd.conf
#AddDefaultCharset WINDOWS-1251

`cp -f /etc/httpd/conf/httpd.conf /etc/httpd/conf/httpd.conf.bak 2>&1`;
open (INI,">/etc/httpd/conf/httpd.conf");
open (BAK,"</etc/httpd/conf/httpd.conf.bak");
while (<BAK>) {
	chomp;
	if ((!/^[;#]/) and ($_ ne '')) {
		/^(\S+)\s*?["']{0,1}([^"']*?)["']{0,1}$/;
		if ($1 eq 'AddDefaultCharset') {
			$_='AddDefaultCharset WINDOWS-1251';
			}
		}
	print INI $_."\n";
	}
close INI;
close BAK;


`cp -f /etc/sysctl.conf /etc/sysctl.conf.bak 2>&1`;
open (INI,">/etc/sysctl.conf");
open (BAK,"</etc/sysctl.conf.bak");
while (<BAK>) {
	chomp;
	if ((!/^[;#]/) and ($_ ne '')) {
		/^(\S+)\s*?=\s*?(.*?)$/;
		if ($1 eq 'net.ipv4.ip_forward') {
			$_='net.ipv4.ip_forward = 1';
			}
		}
	print INI $_."\n";
	}
close INI;
close BAK;


#  mysql  httpd     
chdir('/');
`ln -s /etc/rc.d/init.d/httpd /etc/rc.d/rc3.d/S55httpd`;
`/etc/rc.d/init.d/httpd start`;
`ln -s /etc/rc.d/init.d/mysqld /etc/rc.d/rc3.d/S55mysqld`;
`/etc/rc.d/init.d/mysqld start`;
sleep 10;
# /  ASP9!


$version='1.5';

$find=`which find`; chomp $find;
$tar=`which tar`; chomp $tar;
$mysql=`which mysql`; chomp $mysql;
$mysqladmin=`which mysqladmin`; chomp $mysqladmin;
$ls=`which ls`; chomp $ls;
$ps=`which ps`; chomp $ps;
$ping=`which ping`; chomp $ping;
$grep=`which grep`; chomp $grep;
$sort=`which sort`; chomp $sort;
$iptables=`which iptables`; chomp $iptables;

open (INSTALL,'/var/opt/lingate.install');
while (<INSTALL>) {
	/^(.*?)\s*=\s*(.*)$/;
	$installed{$1}=$2;
	}
close INSTALL;

$mysql_run=`$ps ax | $grep mysqld | grep -v grep`;
die "[!]  : MySQL   \n" if ($mysql_run eq '');

#################################
#     
#################################
@httpds=`$ps auxwww | $grep http | $grep -v grep`;
foreach $httpd (@httpds) {
	$httpd=~/^(\S+)\s+/;
	$httpd_user=$1 if ($1 ne 'root');
	}
if ($httpd_user eq '') {
	print "Apache  .      / .  : ";
	$httpd_user=<>; chomp $httpd_user;
	}
print "[*]    web-: $httpd_user\n";

#################################
#    /opt   
#################################
if ($installed{'targz'} eq $version) {
	print "[s] :   \n";
	}
else {
	chdir('/opt');
	print "[w]   ...";
	$err=`$tar xzf /mnt/cdrom/lingate.tar.gz 2>&1`;
	die "\n[!]  :   \n" if ($err ne '');
	`chown -R root.$httpd_user /opt/lingate`;
	print "\n";
	&install('targz');
	}

#################################
#  PHP,     php.ini
#################################
print "[*]   PHP  /usr...\n";
@phps=`$find /usr -type f -perm +444 -path '*/php'`; chomp @phps;

if (@phps) {
	if (@phps==1) {
		$php=$phps[0];
		}
	else {
		print "   PHP\n";
		for ($i=1;$i<@phps+1;$i++) {
			print $i.': '.$phps[$i-1]."\n";
			}
		print "$i:     PHP \n...   N: ";
		do {
			$number=<>;
			} while ( ($number<0) || ($number>(@phps+1)) );
		if ($number==$i) {
			print "   PHP: ";
			$php=<>;
			chomp $php;
			}
		else {
			$php=$phps[$number-1];
			}
		}
	}
else {
	print " PHP  ,    PHP: ";
	$php=<>;
	chomp $php;
	}

$_=`$php -v`; /(\d+\.\d+\.\d+)/; $php_version=$1;
die "[!]  :    PHP ($php)\n" if ($php_version eq '');
$_=`$php -i`;
if (/Configuration File \(php\.ini\) Path =\> (.*)/) {
	# cli
	$php_ini=$1;
	} # \>
elsif (/\>Configuration File \(php\.ini\) Path.*?\>([^<]+)\<\/td\>\<\/tr\>/) {
	# html
	$php_ini=$1;
	}
if ($php_ini!~/php\.ini/) {
	$php_ini.='/php.ini';
	}
die "[!]  :    php.ini ($php)\n" if ($php_ini eq '');
print " PHP v.$php_version: [$php].\n  php.ini: $php_ini\n";


#################################
#  php.ini    
#################################
open (TMP,"/mnt/cdrom/TurckLoader/$php_version/TurckLoader.so") or
	die "[!]  :     TurckLoader    PHP (v.$php_version)\n";
close TMP;
print "[*]    php.ini.     $php_ini.bak\n";
`cp -f $php_ini $php_ini.bak 2>&1`;
open (INI,">$php_ini");
open (BAK,"<$php_ini.bak");
$extension_need=1;
$safe_mode_need=1;
while (<BAK>) {
	chomp;
	if ((!/^[;#]/) and ($_ ne '')) {
		/^(\S+)\s*?=\s*?["']{0,1}([^"']*?)["']{0,1}$/;
		if ($1 eq 'safe_mode') {
			$_='safe_mode = On';
			$safe_mode_need=0;
			}
		elsif ($1 eq 'register_globals') {
			$_='register_globals = On';
			}
		elsif ($1 eq 'safe_mode_exec_dir') {
			$safe_mode_exec_dir=$2 if ($2 ne '');
			}
		elsif ($1 eq 'extension_dir') {
			$extension_dir=$2 if ($2 ne '');
			}
		elsif ($1 eq 'extension') {
			$extension_need=0 if ($2 eq 'TurckLoader.so');
			}
		}
	print INI $_."\n";
	}
if ($safe_mode_need) {
	print INI "safe_mode = On\n";
	}
if ($safe_mode_exec_dir eq '') {
	print INI "safe_mode_exec_dir=/opt/lingate/safe_php\n";
	$safe_mode_exec_dir='/opt/lingate/safe_php';
	}
if ($extension_dir eq '') {
	print INI "extension_dir=/opt/lingate/extension_php\n";
	$extension_dir='/opt/lingate/extension_php';
	}
if ($extension_need) {
	print INI "extension=TurckLoader.so\n";
	print "[w]    PHP TurckLoader  /mnt/cdrom/TurckLoader/$php_version/TurckLoader.so  $extension_dir\n";
	`cp /mnt/cdrom/TurckLoader/$php_version/TurckLoader.so $extension_dir/`;
	}
close INI;
close BAK;
print "[w]   php.ini .   lingate   apache\n";


#################################
#    ,  
#################################
print "\n   (MySQL)    lingate\n";
print "    (, lingate): ";
do { $db=<>; chomp $db; } while ( ($db!~/^\w+$/) || ($db eq '') );
print "        (, lingate): ";
do { $user=<>; chomp $user; } while ( ($user!~/^\w+$/) || ($user eq '') );
print "      : ";
do { $pass=<>; chomp $pass; } while ( ($pass!~/^\S+$/) || ($pass eq '') );
print "  ? [Y/N]: ";
do { $exist=<>; chomp $exist; $exist=lc $exist; } while ( ($exist ne 'y') && ($exist ne 'n') );
if ($exist eq 'n') {
	#[+]  ,    login [root]   [].   . ,   .
	print "  MySQL  (, root): ";
	do { $root_user=<>; chomp $root_user; } while ( ($root_user!~/^\w+$/) || ($root_user eq '') );
	print "  MySQL : ";
	$root_pass=<>; chomp $root_pass;
	$to_exec="$mysqladmin -u$root_user ".(($root_pass)?"-p$root_pass ":'')."create $db 2>&1";
	$err=`$to_exec`;
	die "[!]  :    $db\n[!] MySQL : $err\n" if ($err ne '');
	$to_exec="echo \"grant all privileges on $db.* to $user\@localhost identified by '$pass'\" | mysql -u$root_user ".(($root_pass)?"-p$root_pass ":'')."2>&1";
	$err=`$to_exec`;
	die "[!]  :      $user   $db\n[!] MySQL : $err\n" if ($err ne '');
	print "[w]   $db .       $user\n";
	}
@files=`$ls /opt/lingate/install/*.sql | $sort`; chomp @files;
foreach $file (@files) {
	$err=`$mysql -u$user -p$pass $db < $file 2>&1`;
	die "[!]  :    $file  MySQL  $db\n[!] MySQL : $err\n" if ($err ne '');
	}
print "[w]     \n";


#################################
#   iptables, ,  ,  
#################################
$my_secret=int(rand()*100000000);
open (CRON,">>/etc/crontab");
print CRON "* * * * * root /opt/lingate/lib/daemon.php 2>/dev/null >/dev/null\n";
close CRON;
print "[w]  /etc/crontab    daemon.php\n";

open (START,">>/etc/rc.d/rc.local");
print START "/opt/lingate/lib/start.php\n";
close START;
print "[w]  /etc/rc.d/rc.local ( )   start.php\n";

`cp $ping $safe_mode_exec_dir/`;
`chown root.$httpd_user $safe_mode_exec_dir/ping`;
`chmod 750 $safe_mode_exec_dir/ping`;
`chmod u+s $safe_mode_exec_dir/ping`;
print "[w]  ping    $safe_mode_exec_dir    lingate\n";

`chown root.$httpd_user $iptables`;
`chmod 750 $iptables`;
`chmod u+s $iptables`;
print "[w]  $iptables   root.$httpd_user 750 +SUID    lingate\n";

open (ROUTE,'/proc/net/route');
while (<ROUTE>) {
	if (/^(\S+)\s+00000000\s+/) {
		$ext_dev=$1;
		break;
		}
	}
close ROUTE;
if ($ext_dev eq '') {
	print "[?]      .   ( eth0): ";
	do { $ext_dev=<>; chomp $ext_dev; } while ( ($ext_dev!~/^\S+$/) || ($ext_dev eq '') );
	}
else {
	print "[*]     $ext_dev\n";
	}

print "[?]  HTTP ,     lingate:";
do { $web_host=<>; chomp $web_host; } while ( ($web_host!~/^\S+$/) || ($web_host eq '') );


open (CONFIG,'>/opt/lingate/lingate.local.conf');
print CONFIG "<?
\$IPTABLES['PATH']  ='iptables-wrapper.sh';
\$IPTABLES['SECRET']='$my_secret';
\$IPTABLES['DEV']   ='$ext_dev';

\$SQUID['access.log']='/var/log/squid/access.log';
\$NACCTD['log']='/var/log/net-acct';

\$WEB_HOST='$web_host';

\$db=new db('localhost','$user','$pass','$db');
?>
";
close CONFIG;
print "[w]    /opt/lingate/lingate.local.conf.    \n";

open (LIB,'>/opt/lingate/lib/start.php');
print LIB "#!$php\n";
close LIB;
open (LIB,'>/opt/lingate/lib/daemon.php');
print LIB "#!$php\n";
close LIB;
open (LIB,'>/opt/lingate/lib/squid.rotate.php');
print LIB "#!$php\n";
close LIB;
`cat /opt/lingate/install/lib/start.php >> /opt/lingate/lib/start.php`;
`cat /opt/lingate/install/lib/daemon.php >> /opt/lingate/lib/daemon.php`;
`cat /opt/lingate/install/lib/squid.rotate.php >> /opt/lingate/lib/squid.rotate.php`;
`chmod +x /opt/lingate/lib/start.php`;
`chmod +x /opt/lingate/lib/daemon.php`;
`chmod +x /opt/lingate/lib/squid.rotate.php`;
print "[w]     /opt/lingate/lib     PHP\n";

open (LIB,">$safe_mode_exec_dir/iptables-wrapper.sh");
print LIB "#!/bin/sh

SECRET=\$1

if [ \$SECRET = '$my_secret' ]; then
	shift
	$iptables \$*
fi
";
close LIB;
`chmod +x $safe_mode_exec_dir/iptables-wrapper.sh`;
print "[w]   $safe_mode_exec_dir/iptables-wrapper.sh    lingate  iptables\n";

`/etc/rc.d/init.d/httpd restart`;
print "[*]  apache\n";


print "


  !
     Lingate-
    : apache, network, mysql.

*******************************************************
***  Enter      ***
*******************************************************
";<>;


sub install() {
	my $module=shift;
	
	$installed{$module}=$version;
	open (INSTALL,'>/var/opt/lingate.install');
	foreach $key (keys %installed) {
		print INSTALL $key.'='.$installed{$key}."\n";
		}
	close INSTALL;
	}
